using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_HotelPuntoVenta._1_Datos
{
    public class HPV_PLV_SalasPrecios_Datos
    {
        #region MODELOS

        #region Modelo Listado
        private List<HPV_PLV_SalasPrecios> g_lst_HPV_PLV_SalasPrecios = null;

        public List<HPV_PLV_SalasPrecios> Obtener_ModeloListado_Por_IdPLV(long _lng_idPLV)
        {
            try
            {
                //Consulta
                string str_SQL = Obtener_Consulta_Modelo() +
                                   //WHERE
                                   " WHERE  " + nameof(HPV_PLV_SalasPrecios) + "." + nameof(HPV_PLV_SalasPrecios.idPLV) + "=@idPLV ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idPLV",  _lng_idPLV)
                };

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                 arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLV_SalasPrecios_Datos) + "/" + nameof(Obtener_ModeloListado_Por_IdPLV), true);
            }

            return g_lst_HPV_PLV_SalasPrecios;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                   object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_HPV_PLV_SalasPrecios = obj_Exferia_Entities.Database.SqlQuery<HPV_PLV_SalasPrecios>(_str_SQL, _arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLV_SalasPrecios_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(HPV_PLV_SalasPrecios.idPLV) + "," +
                    nameof(HPV_PLV_SalasPrecios.idSala) + "," +
                    nameof(HPV_PLV_SalasPrecios.precio) + "," +
                    nameof(HPV_PLV_SalasPrecios.descuento) +
                " FROM " + nameof(HPV_PLV_SalasPrecios);
        }
        #endregion

        #region Grabar
        public INTERNO_ValorDevuelto_Modelo Grabar(long _lng_idPLV, List<HPV_PLV_SalasPrecios> _lst_HPV_PLV_SalasPrecios)
        {
            Exferia_Entities dbcontext = null;
            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                dbcontext = new Exferia_Entities();
                dbcontext.Configuration.ProxyCreationEnabled = true;

                //Borrar Relaciones Antiguas ..............................................
                string str_SQL_Borrar = " DELETE FROM " + nameof(HPV_PLV_SalasPrecios) + " WHERE " + nameof(HPV_PLV_SalasPrecios.idPLV) + "=" + _lng_idPLV;
                dbcontext.Database.ExecuteSqlCommand(str_SQL_Borrar);
                //.........................................................................

                //Grabar Relaciones Nuevas .................................................
                if (_lst_HPV_PLV_SalasPrecios != null & _lst_HPV_PLV_SalasPrecios.Count > 0)
                {
                    string str_SQL_Insertar = "";
                    foreach (HPV_PLV_SalasPrecios mdl_HPV_PLV_SalasPrecios in _lst_HPV_PLV_SalasPrecios)
                    {
                        str_SQL_Insertar += " INSERT INTO " + nameof(HPV_PLV_SalasPrecios) + "(" + nameof(HPV_PLV_SalasPrecios.idPLV) + "," + nameof(HPV_PLV_SalasPrecios.idSala) + "," + nameof(HPV_PLV_SalasPrecios.precio) + "," + nameof(HPV_PLV_SalasPrecios.descuento) + ") values (" + _lng_idPLV + "," + mdl_HPV_PLV_SalasPrecios.idSala + "," + mdl_HPV_PLV_SalasPrecios.precio.ToString().Replace(',', '.') + "," + mdl_HPV_PLV_SalasPrecios.descuento.ToString().Replace(',', '.') + ")";
                    }

                    dbcontext.Database.ExecuteSqlCommand(str_SQL_Insertar);
                }
                //.........................................................................
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(HPV_PLV_SalasPrecios_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                dbcontext.Database.Connection.Close();
                dbcontext.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}
